unit MainUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, Buttons, ExtCtrls;

const
  WADO_ = '57 41 44 4F 01 ';  // + IntToHex(bits,2); // write one byte to all bits
  RADI  = '52 41 44 49';
  CMOT_ = '43 4d 4f 54';      // + loop[8] ' ' + IntToHex(MSB(delay[loop], 2) + ' ' + IntToHex(LSB(delay[loop], 2) endloop;
  
type
  TForm1 = class(TForm)
    MainStatus: TStatusBar;
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    IPEdit: TEdit;
    SendTextEdit: TEdit;
    SendHexEdit: TEdit;
    ReplyTextEdit: TEdit;
    ReplyHexEdit: TEdit;
    GoButton: TButton;
    butSelectTestIP: TButton;
    butSelectFactoryDefIP: TButton;
    butHealthspotIP: TButton;
    butToggleScripting: TButton;
    Panel2: TPanel;
    Splitter1: TSplitter;
    BMoveUp: TButton;
    BMoveDown: TButton;
    ScriptList: TListBox;
    BLoadFromFile: TButton;
    BSaveToFile: TButton;
    BitBtn1: TBitBtn;
    ButtonRun: TBitBtn;
    BitBtn2: TBitBtn;
    ButtonExit: TButton;
    Panel3: TPanel;
    Label8: TLabel;
    SButtonRepeat100: TSpeedButton;
    SButtonRepeat10000: TSpeedButton;
    Label9: TLabel;
    PauseTime: TEdit;
    EditRepeat: TEdit;
    UpDown1: TUpDown;
    RunSlow: TCheckBox;
    W8: TButton;
    W16: TButton;
    W32: TButton;
    R8: TButton;
    R16: TButton;
    R32: TButton;
    BPause: TButton;
    BRepeat: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    memoScript: TMemo;
    butConnect: TButton;
    panelTools: TPanel;
    Button10: TButton;
    Button14: TButton;
    Button15: TButton;
    Button16: TButton;
    Button17: TButton;
    Button18: TButton;
    Button19: TButton;
    Button20: TButton;
    Button21: TButton;
    Button22: TButton;
    Button23: TButton;
    Button24: TButton;
    Button25: TButton;
    Button26: TButton;
    Button27: TButton;
    Button28: TButton;
    Button29: TButton;
    Button30: TButton;
    butDisconnect: TButton;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    procedure SendTextEditChange(Sender: TObject);
    procedure SendHexEditChange(Sender: TObject);
    procedure GoButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure butSelectTestIPClick(Sender: TObject);
    procedure butSelectFactoryDefIPClick(Sender: TObject);
    procedure butHealthspotIPClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure butGoClick(Sender: TObject);
    procedure butToggleScriptingClick(Sender: TObject);
    procedure butCMOT_ON(Sender: TObject);
    procedure butConnectClick(Sender: TObject);
    procedure SetTaggedBit(Sender: TObject);
    procedure ClrTaggedBit(Sender: TObject);
    procedure butCMOT_OFF(Sender: TObject);
    procedure butDisconnectClick(Sender: TObject);
  protected
    procedure SetStatus(NewStatus: String);
  private
    bits: byte;
    DevHandle: Longword;
    procedure InsertPauseClick(Sender: TObject);
    procedure InsertReadClick(Sender: TObject);
    procedure InsertWriteClick(Sender: TObject);
    function ConnectToETH(IPasStr: String): Longword;
    function WriteToETH(msg: String): Longword;
    function DisconnectFromETH: Longword;
    procedure DoWrite(const msg: String); overload;
    procedure DoConnect(ip: string);
    procedure ClrBit(whichBit: byte);
    procedure SetBit(whichBit: byte);
    procedure DoWrite; overload;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

uses
  AIOETHW;

function AEW_DEB_StrToStr(uClientRef: LongWord; pSendPacketBytes: PLongInt; pSendPacket: PChar; pReplyPacketBytes: PLongInt; pReplyPacket: PChar): LongWord; cdecl; external 'AIOETHW.dll';

function NybbleToHex(N: Byte): Char;
begin
  N := N and $F;
  if N < 10 then
    Result := Char(Byte('0') + N)
  else
    Result := Char(Byte('A') - 10 + N)
  ;
end;

function StrToSpacedHex(Text: String): String;
var
  I, L: Integer;

begin
  L := Length(Text);
  if L = 0 then begin
    Result := '';
    Exit;
  end;

  Result := StringOfChar(' ', Length(Text) * 3 - 1);
  for I := 1 to Length(Text) do begin
    Result[I * 3 - 2] := NybbleToHex(Byte(Text[I]) shr 4);
    Result[I * 3 - 1] := NybbleToHex(Byte(Text[I])      );
  end;
end;

function StringReplaceC(const S: String; const OldChar, NewChar: Char): String;
var
  I: Integer;

begin
  Result := S;
  for I := 1 to Length(Result) do
    if Result[I] = OldChar then
      Result[I] := NewChar
  ;
end;

function ValidateHexText(S: String): String;
var
  Content: TStringList;
  Buf: String;
  I, L: Integer;

begin
  S := StringReplaceC(S, ',', #13);
  S := StringReplaceC(S, ' ', #13);
  Content := TStringList.Create;
  //try
    Content.Text := S;
    S := '';
    for I := Content.Count - 1 downto 0 do //Clear blank bytes and double delimiters
      if Length(Content[I]) = 0 then
        Content.Delete(I)
    ;
    L := Content.Count;
    SetString(Result, nil, L);
    for I := 0 to L - 1 do begin
      Buf := Content[I];
      Result[I + 1] := Char(StrToInt('$' + Buf));
    end;
  //finally
    Content.Free;
 // end;
end;

var
  bProgrammatic: Boolean = False;

procedure TForm1.FormCreate(Sender: TObject);
begin
  SendTextEdit.Text := ValidateHexText(SendHexEdit.Text);
  ReplyTextEdit.Text := ValidateHexText(ReplyHexEdit.Text);
  bits := $FF; // all FETs off
end;

procedure TForm1.SendTextEditChange(Sender: TObject);
begin
  if bProgrammatic then Exit;
  try
    bProgrammatic := True;

    SendHexEdit.Text := StrToSpacedHex(SendTextEdit.Text);

  finally
    bProgrammatic := False;
  end;
end;

procedure TForm1.SendHexEditChange(Sender: TObject);
begin
  if bProgrammatic then Exit;
  try
    bProgrammatic := True;

    SendTextEdit.Text := ValidateHexText(SendHexEdit.Text);

  finally
    bProgrammatic := False;
  end;
end;

// returns device handle or 0 & GetLastError
function TForm1.ConnectToETH(IPasStr:String):Longword;
  var
    IPStr: String;
begin
  SetStatus('Connecting...');
  IPStr := IPasStr;
  Result := AEW_Connect(PChar(IPStr), 0);
  if Result = 0 then begin
    SetStatus('Error ' + IntToStr(GetLastError) + ' on AEW_Connect.');
  end else
    DevHandle := Result;
end;

function TForm1.WriteToETH(msg:String) : Longword;
  var
    SendStr, ReplyStr: String;
    SendLen, ReplyLen: LongInt;
begin
  SetStatus('Sending...');
  SendStr := ValidateHexText(msg);
  SendLen := Length(SendStr);
  ReplyLen := 1024;
  ReplyStr := StringOfChar('?', ReplyLen);
  Result := AEW_DEB_StrToStr(DevHandle, @SendLen, PChar(SendStr), @ReplyLen, @ReplyStr[1]);
  if Result <> ERROR_SUCCESS then
    SetStatus('Error ' + IntToStr(Result) + ' on AEW_DEB_StrToStr.')
  else begin
    SetLength(ReplyStr, ReplyLen);
    ReplyTextEdit.Text := ReplyStr;
    ReplyHexEdit.Text := StrToSpacedHex(ReplyStr);
  end;
end;

function TForm1.DisconnectFromETH: Longword;
begin
  result := AEW_Disconnect(DevHandle);
end;

procedure TForm1.GoButtonClick(Sender: TObject);
begin
  if ConnectToETH(IPEdit.Text) = 0 then
    Exit;

  WriteToETH(SendHexEdit.Text);

  SetStatus('');
end;

function MSB(const value: word): byte;
begin
  Result := (value shr 8) and $FF;
end;

function LSB(const value: word): byte;
begin
  Result := value and $FF;
end;

procedure TForm1.DoWrite(const msg:String); 
  var _msg:string;
begin
  _msg := msg;
  if WriteToETH(msg) = 0 then _msg := _msg + ' > OK';
  memoScript.Lines.Add('W:' + _msg);
end;

procedure TForm1.DoWrite;
  var _msg:string;
begin
  _msg := WADO_ + IntToHex(bits, 2);
  if WriteToETH(_msg) = 0 then _msg := _msg + ' > OK';
  memoScript.Lines.Add('W:' + _msg);
end;

procedure TForm1.DoConnect(ip:string);
  var _msg:string;
begin
  _msg:= 'Connecting @ '+ip+' ...';
  if ConnectToETH(ip) = 0 then _msg:= _msg+' NAK' else _msg:=_msg+' OK';
  memoScript.Lines.Add(_msg);
end;

procedure TForm1.SetBit(whichBit: byte);
  var
    currentBits: byte;
    reply:string;
begin
  WriteToETH(RADI);
  reply := ReplyHexEdit.Text;
  reply := copy(reply, length(reply)-1, MAXINT);
  currentBits := StrToInt('$' + reply);
  bits := currentBits and ($FF xor (1 shl whichBit));
end;

procedure TForm1.ClrBit(whichBit: byte);
  var
    currentBits: byte;
    reply:string;
begin
  WriteToETH(RADI);
  reply := ReplyHexEdit.Text;
  reply := trim(copy(reply, length(reply)-1, MAXINT));
  currentBits := StrToInt('$' + reply);
  bits := currentBits or (1 shl whichBit);
end;

procedure TForm1.butCMOT_ON(Sender: TObject);
  var
    SendStr: String;
    i : byte;
    delay: array[0..7] of word;
begin
  // init CMOT configuration array "delay[0..7]"
  for i := 0 to 7 do
    if i > 1 then delay[i] := 6 else delay[i] := 0;

  // convert delay array to CMOT command string
  // Configure CMOT
  SendStr := CMOT_;
  for i := 0 to 7 do
    SendStr := SendStr + ' ' + IntToHex(MSB(delay[i]), 2) + ' ' + IntToHex(LSB(delay[i]), 2);
  DoWrite(SendStr);
end;

procedure TForm1.SetStatus(NewStatus: String);
begin
  MainStatus.Panels[0].Text := NewStatus;
  MainStatus.Update;
end;

procedure TForm1.butSelectTestIPClick(Sender: TObject);
begin
  IPEdit.Text := '10.1.1.251';
end;

procedure TForm1.butSelectFactoryDefIPClick(Sender: TObject);
begin
  IPEdit.Text := '192.168.0.174';
end;

procedure TForm1.butHealthspotIPClick(Sender: TObject);
begin
  IPEdit.Text := '192.168.1.174';
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  SendHexEdit.Text := '43 4d 4f 54 0 0 0 0 0 6 0 6 0 6 0 6 0 6 0 6';
end;

procedure TForm1.butGoClick(Sender: TObject);
var
    Tokens:TStringList;
    i: word;
    state: integer;
    cmd: String;
    ScriptLine: integer;
    Script: array [0..999,0..2] of longword;
    RepeatListIndex: integer;
    RepeatList: array[0..15] of integer;
    SCriptList2: TStringList;
begin
  Tokens := TStringList.Create;
  ScriptList2 := TStringList.Create;
  ScriptList2.text := ScriptList.items.text;
  ScriptLine := 0;
  RepeatListIndex := 0;
  if ScriptList.Items.Count > 0 then begin
    Tokens.Text := StringReplace( ScriptList.Items.text, #9, #13, [rfReplaceAll] );
    state := 0;//get command char
    for i := 0 to Tokens.Count-1 do begin
      case state of
        0:begin
            inc(state);
            inc(ScriptLine);
            cmd := Tokens[i];
            if cmd = 'W8' then Script[ScriptLine,0] := 1
              else if cmd = 'W16' then Script[ScriptLine,0] := 2
                else if cmd = 'W32' then Script[ScriptLine,0] := 3
                  else if cmd = 'R8' then Script[ScriptLine,0] := 4
                    else if cmd = 'R16' then Script[ScriptLine,0] := 5
                      else if cmd = 'R32' then Script[ScriptLine,0] := 6
                        else if cmd = 'Pause' then Script[ScriptLine,0] := 7
                          else if cmd = 'Start' then
                                                begin
                                                  Script[ScriptLine,0] := 8;
                                                  RepeatList[RepeatListIndex] := ScriptLine;
                                                  inc(RepeatListIndex);
                                                  State := 0;
                                                end
                            else if cmd = 'End' then Script[ScriptLine,0] := 9
                              else if cmd[1] = '=' then begin
                                                        dec(state);
                                                        dec(ScriptLine);
                                                      end
                                else Application.MessageBox('Error #8.1 Contact John Hentges','syntax error',0);
            if tokens[i][1] <> '=' then inc(Script[0,0])//increment count of script lines stored at 0,0
          end;
        1:begin
            case Script[ScriptLine,0] of
              1..3: begin
                      Script[ScriptLine,1]:=StrToInt('$0'+Tokens.Strings[i]); //get first param
                      inc(state);//outports have another param
                    end;
              4..7: begin
                      Script[ScriptLine,1]:=StrToInt('$0'+Tokens.Strings[i]); //get first param
                      state:=0;
                    end;
                 8: begin
                       //must never happen
                       Application.MessageBox('Error #8.2 Contact John Hentges','syntax error',0);
                    end;
                 9: begin     //LoopEnd: sets location to jump to, an count of times to jump
                      Script[ScriptLine,1] := StrToInt(Tokens.Strings[i]);//get repeat count
                      dec(RepeatListIndex);
                      Script[ScriptLine,2] := RepeatList[RepeatListIndex];//set label to jump to
                      state := 0;
                    end;
            end;//case
          end;
        2:begin
            Script[ScriptLine,2] := StrToInt('$0' + Tokens.Strings[i]);//get value to write
            state := 0;
          end;
        else begin Application.MessageBox('Contact John Hentges','state error',0);end;
      end;//case
    end;//for i
  end;//if any strings in script
  Tokens.Free;

  i:=1;
{
  repeat  //END SCRIPT EXECUTION LOOP
    case Script[i,0] of
      1:OutPortB(Script[i,1],Script[i,2]);
      2:OutPort(Script[i,1],Script[i,2]);
      3:OutPortDWord(Script[i,1],Script[i,2]);
      4:Script[i,2]:=InPortB(Script[i,1]);
      5:Script[i,2]:=InPort(Script[i,1]);
      6:Script[i,2]:=InPortDWord(Script[i,1]);
      7:begin end;//pause
      8:begin  end;                     //do nothing, this is merely a label.
      9:begin
          if Script[i,1]>=1 then begin
            dec(Script[i,1]);
            i:=Script[i,2];
          end;//if still looping
        end;//Loop x times
      else begin end;
    end;//case
    if RunSlow.Checked then begin
      if Script[i,0] in [4,5,6] then begin
        cmd:=IntToHex(Script[i,2],1 shl (Script[i,0]-3));
        LabelRead.Caption:=cmd;
        ScriptList.Items[i-1]:=ScriptList2.strings[i-1]+#9+'='+cmd;
      end
    end;
    inc(i);
  until i>Script[0,0]; //END SCRIPT EXECUTION LOOP
}
  // display read results
  if not RunSlow.checked then begin
    ScriptList.Items.BeginUpdate;
    for i:=1 to Script[0,0] do begin
      if Script[i,0] in [4,5,6] then begin
        cmd := IntToHex(Script[i,2],1 shl (Script[i,0]-3));
        // LabelRead.Caption := cmd;
        ScriptList.Items[i-1] := ScriptList2.strings[i-1] + #9 + '=' + cmd;
      end;
    end; // for i
    ScriptList.Items.EndUpdate;
  end; // NOT RunSlow
end;

procedure TForm1.butToggleScriptingClick(Sender: TObject);
begin
  Panel2.Visible:=not panel2.Visible;
  if Panel2.Visible=True then begin
    butToggleScripting.Caption:='Hide Scripting <<';
    Form1.Width:=Form1.Width+Panel2.Width;
    Form1.Constraints.MinHeight:=Form1.Constraints.MinHeight+Panel3.Height;
    Form1.Constraints.MinWidth:=Form1.Constraints.MinWidth+Panel2.Width;
    Panel2.Anchors:=[akLeft,akBottom,akTop,akRight];
  end
  else begin
    Panel2.Anchors:=[];
    butToggleScripting.Caption:='Show Scripting >>';
    Form1.Constraints.MinHeight:=Form1.Constraints.MinHeight-Panel3.Height;
    Form1.Constraints.MinWidth:=Form1.Constraints.MinWidth-Panel2.Width;
    Form1.Width:=Form1.Width-Panel2.Width;
  end
end;

procedure TForm1.InsertWriteClick(Sender: TObject);
var foo:TButton;
begin
  foo:=Sender as TButton;
//  ScriptList.Items.Append(Format('%s'#9'%.4x'#9'%x',[foo.Name,StrToInt('$0'+EditBase.Text)+StrToInt('$0'+EditOffset.Text),StrToInt('$0'+Copy(EditValue.Text,Length(EditValue.Text)-foo.tag+1,foo.tag))]));
end;

procedure TForm1.InsertReadClick(Sender: TObject);
begin
//  ScriptList.Items.Append(Format('%s'#9'%.4x',[(Sender as TButton).Name,StrToInt('$0'+EditBase.Text)+StrToInt('$0'+EditOffset.Text)]));
end;

procedure TForm1.InsertPauseClick(Sender: TObject);
begin
//  ScriptList.Items.Append(Format('Pause'#9'%d',[StrToInt(PauseTime.Text)]));
end;





procedure TForm1.butConnectClick(Sender: TObject);
begin
  DoConnect(IPEdit.Text);
  panelTools.Visible := DevHandle <> 0;
end;



procedure TForm1.SetTaggedBit(Sender: TObject);
begin
  SetBit((Sender as TButton).Tag);
  DoWrite;
end;

procedure TForm1.ClrTaggedBit(Sender: TObject);
begin
  ClrBit((Sender as TButton).Tag);
  DoWrite;
end;

procedure TForm1.butCMOT_OFF(Sender: TObject);
  var
    SendStr: String;
    i : byte;
    delay: array[0..7] of word;
begin
  // init CMOT configuration array "delay[0..7]"
  for i := 0 to 7 do delay[i] := 0;

  // convert delay array to CMOT command string
  // Configure CMOT
  SendStr := CMOT_;
  for i := 0 to 7 do
    SendStr := SendStr + ' ' + IntToHex(MSB(delay[i]), 2) + ' ' + IntToHex(LSB(delay[i]), 2);
  DoWrite(SendStr);
end;

procedure TForm1.butDisconnectClick(Sender: TObject);
begin
  panelTools.Visible := DisconnectFromETH <> ERROR_SUCCESS;
end;

end.
